//Write a C program to demonstrate thread synchronization with mutex locks.
#include <pthread.h>
#include <stdio.h>
#define NUM_THREADS     2
static pthread_mutex_t *mylock=PTHREAD_MUTEX_INITIALIZER;

void *PrintHello(void *threadid)
{
int i,j;
   
long tid;
   tid = (long)threadid;
pthread_mutex_lock(&mylock);
for(i=0;i<5;i++)
{
   printf("Hello World! It's me, thread #%ld!\n", tid);
for(j=0;j<500000;j++);
}
pthread_mutex_unlock(&mylock);
   pthread_exit(NULL);
}

int main (int argc, char *argv[])
{
   pthread_t threads[NUM_THREADS];
   int rc;
   long t;
   for(t=0; t<NUM_THREADS; t++){
      printf("In main: creating thread %ld\n", t);
      rc = pthread_create(&threads[t], NULL, PrintHello, (void *)t);

      if (rc){
         printf("ERROR; return code from pthread_create() is %d\n", rc);
         exit(-1);
      }
   }

   /* Last thing that main() should do */
   pthread_exit(NULL);
}
